| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CS::Memory::AllocatorHeapBase< HeapAccess > Class Template Reference

A memory allocator that allocates from a heap. More...

`#include <csutil/memheap.h>`

Inheritance diagram for CS::Memory::AllocatorHeapBase< HeapAccess >:

[legend]
List of all members.

## Public Member Functions
void * | Alloc (const size_t n)
| Allocate a block of memory of size `n`.
| AllocatorHeapBase (const HeapAccess &heap)
| AllocatorHeapBase ()
void | Free (void *p)
| Free the block `p`.
void * | Realloc (void *p, size_t newSize)
| Resize the allocated block `p` to size `newSize`.
void | SetMemTrackerInfo (const char *info)
| Set the information used for memory tracking.

## Detailed Description

### template<class HeapAccess>
class CS::Memory::AllocatorHeapBase< HeapAccess >

A memory allocator that allocates from a heap.

The `HeapAccess` template argument should behave like the Heap class.

See also:
  HeapAccessPointer

Definition at line 79 of file memheap.h.

## Member Function Documentation

template<class HeapAccess>

void* CS::Memory::AllocatorHeapBase< HeapAccess >::Alloc | ( | const size_t | n | ) | `[inline]`

Allocate a block of memory of size `n`.

Definition at line 93 of file memheap.h.

Referenced by CS::Memory::AllocatorHeapBase< CS::Memory::HeapAccessPointer< HeapPtr > >::Realloc().

template<class HeapAccess>

void CS::Memory::AllocatorHeapBase< HeapAccess >::Free | ( | void * | p | ) | `[inline]`

Free the block `p`.

Definition at line 113 of file memheap.h.

template<class HeapAccess>

void* CS::Memory::AllocatorHeapBase< HeapAccess >::Realloc | ( | void * | p,
|  | size_t | newSize |
| ) |  |  | `[inline]`

Resize the allocated block `p` to size `newSize`.

Definition at line 126 of file memheap.h.

template<class HeapAccess>

void CS::Memory::AllocatorHeapBase< HeapAccess >::SetMemTrackerInfo | ( | const char * | info | ) | `[inline]`

Set the information used for memory tracking.

Definition at line 144 of file memheap.h.

The documentation for this class was generated from the following file:

- csutil/memheap.h